<?php
	include "include/globals.php";
	include "include/mailfunctions.php";
	include $_SESSION['addressbookstorage'];

	$AddressBook = new AddressBook();
	$identities = $AddressBook->GetIdentities();

	$mbox =open_mailbox($_SESSION["currentfolder"]);

	if(isset($_POST["to"])) {
		// build the envelope
		$envelope = array();

		$identity = $AddressBook->GetIdentityInfo($_REQUEST["identity"]);
		if ($identity != false) {
			if ($identity["fromaddress"] != "") {
				$fromaddress = $identity["fromaddress"];
			} else {
				$fromaddress = $_SESSION["emailaddress"];
			}
			$replyto = $identity["replyto"];
			$displayname = $identity["displayname"];
			$organization = $identity["organization"];
		} else {
			$fromaddress = $_SESSION["emailaddress"];
			$replyto = $_SESSION["emailaddress"];
			$displayname = $_SESSION["emailaddress"];
			$organization = "";
		}
		$envelope["reply_to"] = $replyto;
		$envelope["return_path"] = $_SESSION["emailaddress"];
		$envelope["to"] = $_POST["to"];
		$envelope["cc"] = $_POST["cc"];
		$envelope["subject"] = $_POST["subject"];
		$envelope["date"] = gmdate("r", strtotime($_REQUEST["messagedate"]));
		// BCC must be added here because php ignores it otherwise
		$envelope["custom_headers"] = Array("X-Mailer-Version: " . $ismailversion, "X-Mailer: ISMail (http://www.insidesystems.net/projects/project.php?projectid=4)");
		if (!empty($_POST["bcc"])) {
			array_push($envelope["custom_headers"], "Bcc: " . $_POST["bcc"]);
		}
		$envelope["message_id"] = "<" . str_replace(" ", ".", microtime()) . "@" . $_SESSION["domain"] . ">";
		if (isset($_POST["messageid"])) {
			$envelope["in_reply_to"] = $_POST["messageid"];
			$envelope["custom_headers"][count($envelope["custom_headers"])] = "References: " . $_POST["messageid"];
		}
		if (isset($_POST["requestreceipt"])) {
			$envelope["custom_headers"][count($envelope["custom_headers"])] = "Disposition-Notification-To: " . $_SESSION["emailaddress"] . "\" <" . $_SESSION["emailaddress"] . ">";
		}
		if ($organization != "") {
			$envelope["custom_headers"][count($envelope["custom_headers"])] = "Organization: " . $organization;
		}
		$filearr = $_FILES;
		while (list($key, $val) = each($_POST)) {
			if (substr($key, 0, 7) == "fstatus") {
				if ($val == 1) {
					$index = count($filearr);
					$filearr[$index]["tmp_name"] = "users/" . md5($_SESSION["emailaddress"]) . "/fattachments/" . $_POST["fattach" . substr($key, 7)];
					$filearr[$index]["name"] = $_POST["fattach" . substr($key, 7)];
					$filearr[$index]["type"] = exec("file -i -b " . "users/" . md5($_SESSION["emailaddress"]) . "/fattachments/" . $_POST["fattach" . substr($key, 7)]);
				}
			}
		}
		$attachments = array();
		while (list($file, $info) = each($filearr)) {
			if (!is_file($info["tmp_name"])) {
				continue;
			}
			$index = count($attachments);

			// Get all of our pieces for this attachment
			// First, the actual contents
			$fp = fopen($info["tmp_name"],"r");
			$contents = fread($fp,filesize($info["tmp_name"]));
			fclose($fp);
			$attachments[$index]["contents.data"] = $contents;

			// Set our filename stuff
			$attachments[$index]["description"] = basename($info["name"]);
			$attachments[$index]["disposition.type"] = "attachment";
			$attachments[$index]["disposition"] = array("filename"=>basename($info["name"]));
			$attachments[$index]["type.parameters"] = array("name"=>basename($info["name"]));

			// Now, set the mimetype and subtype foo
			$mime = explode("/", $info["type"]);
			$attachments[$index]["subtype"] = $mime[1];
			switch($mime[0]) {
				case "image":
				$attachments[$index]["type"] = TYPEIMAGE;
				break;

				case "text":
				$attachments[$index]["type"] = TYPETEXT;
				break;

				case "audio":
				$attachments[$index]["type"] = TYPEAUDIO;
				break;

				case "video":
				$attachments[$index]["type"] = TYPEVIDEO;
				break;

				case "application":
				$attachments[$index]["type"] = TYPEAPPLICATION;
				break;

				case "other":
				default:
				$attachments[$index]["type"] = TYPEOTHER;
				break;
			}
		}

		$body = array();
		$body[0] = array();
		$body[0]["type"] = TYPETEXT;
		$body[0]["subtype"] = "plain";
		$body[0]["description"] = "messagebody";
		$body[0]["contents.data"] = $_POST["mailbodytext"];
		if ($identity["signature"] != "") {
			$body[0]["contents.data"] .= "\n\n" . $identity["signature"];
		}
		if (count($attachments) > 0) {
			$attachmentheader = array();
			$attachmentheader["type"] = TYPEMULTIPART;
			$attachmentheader["subtype"] = "mixed";
			array_unshift($body, $attachmentheader);
			for ($i = 0; $i < count($attachments); $i++) {
				$index = count($body);
				$body[$index]["type"] = $attachments[$i]["type"];
				$body[$index]["type.parameters"] = $attachments[$i]["type.parameters"];
				$body[$index]["subtype"] = $attachments[$i]["subtype"];
				$body[$index]["description"] = $attachments[$i]["description"];
				$body[$index]["disposition"] = $attachments[$i]["disposition"];
				$body[$index]["disposition.type"] = $attachments[$i]["disposition.type"];
				$body[$index]["contents.data"] = $attachments[$i]["contents.data"];
				$body[$index]["encoding"] = ENCBINARY;
			}
		}

		// send it
		$email = "From: \"" . addslashes($displayname) . "\" <" . $fromaddress . ">\r\n" . imap_mail_compose($envelope, $body);
		$fp = popen($_SESSION['mailprogram'], "w");
		fwrite($fp, $email);
		pclose($fp);

		// Stick a copy in the Sent Items
		if ($_SESSION["protocol"] == "imap") {
			$sentitems = open_mailbox($_SESSION["serverstring"] . $_SESSION["rootfolderpath"] . $_SESSION["sentfoldername"]);
			imap_append($sentitems, $_SESSION["serverstring"] . $_SESSION["rootfolderpath"] . $_SESSION["sentfoldername"], $email);
			$status = imap_check($sentitems);
			imap_setflag_full($sentitems, $status->Nmsgs,'\\SEEN');
			imap_close($sentitems);
		}

		// Mark this message as read if it was a reply (which we know by the set messageid
		if (isset($_REQUEST["messageid"])) {
			// Get the text and the attachment info
			$message = printBody($mbox, 1);
			$headerinfo = @imap_header($mbox, imap_msgno($mbox, $_SESSION["currentmessage"]), 50, 50);
			imap_setflag_full($mbox, $_SESSION["currentmessage"], '\\Answered', ST_UID);
			if ($_SESSION["addrepliestoaddressbook"] == 1) {
				if ($headerinfo->reply_toaddress) {
					$addedentry = $AddressBook->AddEntry(ISDecode($headerinfo->reply_toaddress));
				} else {
					$addedentry = $AddressBook->AddEntry($headerinfo->(ISDecode(fromaddress));
				}
			}
		}

		// close the window if we just sent mail
		echo("<HTML><HEAD><SCRIPT type=\"text/javascript\">\n");
		echo("	window.close();\n");
		echo("</SCRIPT></HEAD><BODY></BODY></HTML>\n");
		imap_close($mbox);
		exit;
	} else if (isset($_GET["reply"]) || isset($_GET["forward"])) {
		// Get the text and the attachment info
		$message = printBody($mbox, 1);

		// get the header information
		$headerinfo = @imap_header($mbox, imap_msgno($mbox, $_SESSION["currentmessage"]), 50, 50);
	} else if (isset($_GET["abid"])) {
		$entry = $AddressBook->GetEntryInfo($_GET["abid"]);
		if ($entry !== false) {
			$name = $entry["name"];
			if (isset($entry["default"])) {
				$email = $entry["default"];
			} else {
				$email = $entry["emails"][0];
			}
			$found = true;
		}
	}
	// Now is where we will set who this is going to
	if(isset($_GET["reply"])) {
		if ($headerinfo->reply_toaddress) {
			$to = $headerinfo->reply_toaddress;
		} else {
			$to = $headerinfo->fromaddress;
		}
	} else if (isset($_GET["abid"]) && isset($found)) {
		$to = $email;
	} else if (isset($_GET["toaddress"])) {
		$to = $_GET["toaddress"];
	} else {
		$to = "";
	}
	if (isset($name) && ($to != "")) {
		$to = "\"" . $name . "\" <" . $to . ">";
	}
	// Now we check to see if this should default to a different identity than default
	$matchedidentity = 0;
	if (isset($headerinfo)) {
		$identitycheck = ParseEmailLine(ISDecode($headerinfo->toaddress));
		for ($i = 0; $i < count($identities); $i++) {
			$identityinfo = $AddressBook->GetIdentityInfo($identities[$i]["id"]);
			if ($identityinfo["replyto"] == $identitycheck["email"]) {
				$matchedidentity = $identities[$i]["id"];
				break;
			}
		}
	}

	PageHeader(1);
?>
<head>
	<title>
		<?php echo(gettext("Send Mail"));?>
	</title>
	<style type="text/css">
		@import "themes/<?php echo($_SESSION["themedir"]);?>/css/globals.css";
		@import "themes/<?php echo($_SESSION["themedir"]);?>/css/sendmail.css";
	</style>
	<script type="text/javascript">
		<!--
		// calls up the address book and inserts the address chosen in the appropriate field
		function insertaddress(elementid)
		{
			window.open('addressbookpopuplist.php?elementid=' + escape(elementid), 'AddAddress', 'height=480,width=200,scrollbars=yes,toolbar=no');

			// get the appropriate text input to put it in
			textinput = document.getElementById(elementid)
			if(textinput.value == '') {
				textinput.value = address;
			}
			else {
				textinput.value = textinput.value + ', ' + address;
			}
		}

		// checks for a subject
		function checkdata()
		{
			if(document.getElementById('to').value == '') {
				alert('<?php echo(addslashes(gettext("You must specify a recipient for this message!")));?>');
				return false;
			}

			if(document.getElementById('subject').value == '') {
				if(!confirm('<?php echo(addslashes(gettext("This message has no subject, are you certain you wish to send it?")));?>')) {
					return false;
				}
			}

			SetMessageDate();
			return true;
		}

		function SetMessageDate() {
			// Set our date to the browsers date so that it gets used instead of the server
			d = new Date();
			document.getElementById('messagedate').value = d.toUTCString();
		}

		function SubmitForm() {
			if (checkdata()) {
				SetMessageDate();
				document.getElementById('sendstatus').style.visibility = 'visible';
				document.getElementById('sendform').submit();
			}
		}

		function AttachFile()
		{
			var attachments = document.getElementById('attachments');

			// Now we attach some crap to our document
			// Get the next highest file id
			var fileid = 0;
			while (document.getElementById('file' + fileid)) {
				fileid++;
			}

			// If there are no files, ditch the 'None'
			if (fileid == 0) {
				attachments.removeChild(attachments.firstChild);
			}

			var span = document.createElement('SPAN');
			span.id = 'filespan' + fileid;

			var file = document.createElement('INPUT');
			file.type = 'file';
			file.id = 'file' + fileid;
			file.name = 'file' + fileid;
			file.size = 30;
			span.appendChild(file);

			var divcontainer = document.createElement('DIV');
			divcontainer.className = 'delete';
			divcontainer.title = '<?php echo(addslashes(gettext("Remove attachment")));?>';
			divcontainer.onclick = Delete;
			span.appendChild(divcontainer);

			var spancontainer = document.createElement('SPAN');
			spancontainer.appendChild(document.createTextNode('<?php echo(addslashes(gettext("Delete")));?>'));
			divcontainer.appendChild(spancontainer);


			var br = document.createElement('BR');
			span.appendChild(br);

			document.getElementById('attachments').appendChild(span);
			SetTabIndex();
		}

		function Delete(e) {
			if (!e) {
				e = window.event;
				span = e.srcElement.parentNode;
			} else {
				span = e.target.parentNode;
			}
			if (span.nodeName == 'DIV') {
				span = span.parentNode;
			}
			span.parentNode.removeChild(span);
			SetTabIndex();

			var attachments = new Object();
			var end = document.getElementById('attachments').childNodes.length;
			for ( i = 0; i < end; i++) {
				attachments[i] = document.getElementById('attachments').firstChild.cloneNode(true);
				document.getElementById('attachments').removeChild(document.getElementById('attachments').firstChild);
			}
			// Re-add the children and set the event (it gets lost for some reason)
			for ( i = 0; i < end; i++) {
				document.getElementById('attachments').appendChild(attachments[i]);
				document.getElementById('attachments').lastChild.firstChild.nextSibling.onclick = Delete;
			}

			// If the last attachment gets deleted, add a None
			if (document.getElementById('attachments').childNodes.length == 0) {
				document.getElementById('attachments').appendChild(document.createTextNode('<?php echo(addslashes(gettext("None")));?>'));
			}
		}

		function SetTabIndex()
		{
			var attachments = document.getElementById('attachments');
			var i = 0;

			for (i = 0; i < attachments.childNodes.length; i++) {
				attachments.childNodes[i].firstChild.tabIndex = 6 + i;
			}
			document.getElementById('mailbodytext').tabIndex = (6 + i);
		}
		-->
	</script>
</head>
<body>
<div id="headercontainer">
	<div id="sendbutton" onclick="SubmitForm()" title="<?php echo(htmlspecialchars(gettext("Send Message")));?>">
		<span><?php echo(gettext("Send Message"));	?></span>
	</div>
	<div id="attachbutton" onclick="AttachFile()" title="<?php echo(htmlspecialchars(gettext("Attach File")));?>">
		<span><?php echo(gettext("Attach File") . "\n");?></span>
	</div>
	<?php
		if ($_SESSION["spellenable"] == true) {
			echo("	<div id=\"spellcheckbutton\" onclick=\"window.open('spellcheck.php?textareaid=mailbodytext', 'spellcheck', 'width=640,height=480,scrollbars=yes')\" title=\"" . htmlspecialchars(gettext("Check Spelling")) . "\">\n");
			echo("		<span>" . gettext("Check Spelling") . "</span>\n");
			echo("	</div>\n");
		}
	?>
	<div id="sendstatus">
		<span><?php echo(gettext("Sending Mail, Please Wait") . "...");?></span>
	</div>
</div>
<form name="sendform" id="sendform" method="post" action="sendmail.php" enctype="multipart/form-data" onsubmit="return SubmitForm()">
<p style="position: absolute">
<?php
	if (isset($headerinfo->message_id) && isset($_GET["reply"])) {
		echo("<input type=\"hidden\" name=\"messageid\" value=\"" . htmlspecialchars($headerinfo->message_id) . "\"/>\n");
	}
	echo("<input id=\"messagedate\" type=\"hidden\" name=\"messagedate\" value=\"\"/>\n");
?>
</p>
<table id="formtable" cellpadding="2" cellspacing="0">
<?php
	if ($identities != false) {
		echo("	<tr>\n");
		echo("		<td class=\"labelcell\">\n");
		echo("			" . gettext("Identity") . ":\n");
		echo("		</td>\n");
		echo("		<td colspan=\"3\" class=\"inputcell\">\n");
		echo("			<select tabindex=\"1\" id=\"identity\" name=\"identity\" size=\"1\" style=\"width: 100%\">\n");
		for ($i = 0; $i < count($identities); $i++) {
			echo("				<option value=\"" . $identities[$i]["id"] . "\"");
			if (($matchedidentity == $identities[$i]["id"]) || (($matchedidentity == 0) && ($identities[$i]["isdefault"] == 1))) {
				echo(" selected=\"selected\"");
			}
			echo(">" . $identities[$i]["name"] . "</option>\n");
		}
		echo("			</select>\n");
		echo("		</td>\n");
		echo("	</tr>\n");
	}
?>
	<tr>
		<td class="labelcell">
			<div class="addressicon" onclick="insertaddress('to')">&nbsp;</div><?php echo(gettext("To") . ":\n");?>
		</td>
		<td colspan="3" class="inputcell">
			<?php
				echo("<input size=\"74\" tabindex=\"2\" type=\"text\" id=\"to\" name=\"to\" value=\"" . htmlspecialchars(ISDecode($to)) . "\"/>\n");
			?>
		</td>
	</tr>
	<tr>
		<td class="labelcell">
			<div class="addressicon" onclick="insertaddress('cc')">&nbsp;</div>CC:
		</td>
		<td colspan="3" class="inputcell">
			<?php
				// if it is a reply to all we need to insert the cc line as well
				if (isset($_GET["replyall"])) {
					// make a proper reply list from the to, cc, and from lines
					$alladdresses = $headerinfo->toaddress . " " . $to;
					if (isset($headerinfo->ccaddress)) {
						$alladdresses .= " " . $headerinfo->ccaddress;
					}
					preg_match_all("/[\w\.]+@[\w\.]+/", $alladdresses, $matches);
					preg_match("/[\w\.]+@[\w\.]+\b/", $to, $tomatch);
					$end = count($matches[0]);
					$alladdresses = '';
					for($i=0;$i<$end;$i++) {
						if($matches[0][$i] == $tomatch[0])
							continue;
						if($alladdresses == '') {
							$alladdresses = $matches[0][$i];
						}
						else {
							$alladdresses = $alladdresses . ", " . $matches[0][$i];
						}
					}
					echo("<input tabindex=\"3\" type=\"text\" name=\"cc\" id=\"cc\" value=\"" . htmlspecialchars($alladdresses) . "\"/>\n");
				}
				else {
					echo("<input tabindex=\"3\" size=\"74\" type=\"text\" name=\"cc\" id=\"cc\"/>\n");
				}
			?>
		</td>
	</tr>
	<tr>
		<td class="labelcell">
			<div class="addressicon" onclick="insertaddress('bcc')">&nbsp;</div>BCC:
		</td>
		<td colspan="3" class="inputcell">
			<input tabindex="4" type="text" size="74" name="bcc" id="bcc"/>
		</td>
	</tr>
	<tr>
		<td class="labelcell">
			<?php echo(gettext("Subject"));?>:
		</td>
		<td colspan="3" class="inputcell">
			<?php
				if (isset($_GET["reply"])) {
					$newsubject = htmlspecialchars(ISDecode($headerinfo->subject));
					if(strtoupper(substr($newsubject, 0, 3)) != "RE:")
						$newsubject = "re: " . $newsubject;
					echo("<input tabindex=\"5\" size=\"74\" type=\"text\" id=\"subject\" name=\"subject\" value=\"" . $newsubject . "\"/>\n");
				} else if (isset($_GET["forward"])) {
					$newsubject = htmlspecialchars(ISDecode($headerinfo->subject));
					if(strtoupper(substr($newsubject, 0, 4)) != "FWD:")
						$newsubject = "fwd: " . $newsubject;
					echo("<input tabindex=\"5\" size=\"74\" type=\"text\" id=\"subject\" name=\"subject\" value=\"" . $newsubject . "\"/>\n");
				} else {
					echo("<input tabindex=\"5\" size=\"74\" type=\"text\" id=\"subject\" name=\"subject\"/>\n");
				}
			?>
		</td>
	</tr>
	<tr>
		<td class="labelcell">
			<?php echo(gettext("Attachments"));?>:
		</td>
		<td id="attachments">
			<?php echo(gettext("None"));?>
		</td>
		<td id="requestlabel">
			<?php echo(gettext("Request Receipt?"));?>
		</td>
		<td id="requestinput">
			<input type="checkbox" name="requestreceipt"/>
		</td>
	</tr>
<?php
	if (isset($_GET["forward"]) && (count($message["attachments"]) > 0)){
		echo("	<tr>\n");
		echo("		<td class=\"labelcell\">\n");
		echo("			" . gettext("Forwarded<br/>Attachments") . ":\n");
		echo("		</td>\n");
		echo("		<td id=\"fattachments\" colspan=3>\n");
		echo("			<table cellpadding=1 cellspacing=0>\n");
		for ($i = 0; $i < count($message["attachments"]); $i++) {
			echo("				<tr id=\"fattachment" . $i . "\">\n");
			echo("					<td class=\"fa\">\n");
			echo("						" . $message["attachments"][$i] . "\n");
			echo("						<input type=\"hidden\" name=\"fattach" . $i . "\" value=\"" . htmlspecialchars($message["attachments"][$i]) . "\">\n");
			echo("						<input type=\"hidden\" id=\"fstatus" . $i . "\" name=\"fstatus" . $i . "\" value=\"1\">\n");
			echo("					</td>\n");
			echo("					<td style=\"width: 20px\">\n");
			echo("						<br/>\n");
			echo("					</td>\n");
			echo("					<td class=\"fa\">\n");
			echo("						<a href=\"#N\" onclick=\"Toggle(" . $i . ", this)\" class=\"ac\">" . gettext("unattach") . "</A>\n");
			echo("					</td>\n");
			echo("				</tr>\n");
		}
		echo("			</table>\n");
		echo("		</td>\n");
		echo("	</tr>\n");
	}
?>
	<tr>
		<td colspan="4" id="textareacell">
			<?php
				if(isset($_GET["reply"]) || isset($_GET["forward"])) {
					// create a message header to indicate the original message
					$replyforwardheader = "--- " . gettext("Original Message") . " ---\n" . gettext("From") . ": " . ISDecode($headerinfo->fromaddress) . "\n" . gettext("Sent") . ": " . $headerinfo->date . "\n" . gettext("To") . ": " . ISDecode($headerinfo->toaddress) . "\n" . gettext("Subject") . ": " . ISDecode($headerinfo->subject) . "\n\n";
					echo("<textarea tabindex=\"6\" id=\"mailbodytext\" name=\"mailbodytext\" rows=\"\" cols=\"\">" . htmlspecialchars($replyforwardheader . $message["body"]) . "</textarea>\n");
				} else {
						echo("<textarea tabindex=\"6\" id=\"mailbodytext\" name=\"mailbodytext\" rows=\"\" cols=\"\"></textarea>\n");
				}
			?>
		</td>
	</tr>
</table>
</form>
<script type="text/javascript">
	<!--
	<?php
		if (isset($_GET["forward"])) {
			echo("	function Toggle(num, obj) {\n");
			echo("		if (document.all) {\n");
			echo("			var bnum = 0;\n");
			echo("		} else {\n");
			echo("			var bnum = 1;\n");
			echo("		}\n");
			echo("		var toggleobj = document.getElementById('fstatus' + num);\n");
			echo("		var nameobj = document.getElementById('fattachment' + num);\n");
			echo("		if (toggleobj.value == 1) {\n");
			echo("			obj.firstChild.nodeValue = 'attach';\n");
			echo("			toggleobj.value = 0;\n");
			echo("			nameobj.childNodes[bnum].style.color = '#606060';\n");
			echo("			nameobj.childNodes[bnum].style.fontStyle = 'italic';\n");
			echo("		} else {\n");
			echo("			obj.firstChild.nodeValue = 'unattach';\n");
			echo("			toggleobj.value = 1;\n");
			echo("			nameobj.childNodes[bnum].style.color = '#000000';\n");
			echo("			nameobj.childNodes[bnum].style.fontStyle = 'normal';\n");
			echo("		}\n");
			echo("	}\n");
		}
		if (isset($addedentry)) {
			if ($addedentry["code"] == 1) {
				echo("	opener.parent.addressbook.location.href = 'addressbook.php';\n");
			} else if ($addedentry["code"] == 0) {
				echo("	alert('" . addslashes(gettext("Unable to add this address to the address book")) . "');\n");
			}

		}

		if (isset($_GET["reply"])) {
			echo("	document.getElementById('mailbodytext').focus();\n");
		} else {
			if ($identities != false) {
				echo("	document.getElementById('identity').focus();\n");
			} else {
				echo("	document.getElementById('to').focus();\n");
			}
		}
	?>
	
	// In case the form validation doesn't get called, we'll at least set it to when the window was opened
	SetMessageDate();
	// -->
</script>
</body>
<?php
	imap_close($mbox);
?>
</html>
